#ifndef FONT_H
#define FONT_H

#include <inttypes.h>



#define SLM1606M_RED    0x01
#define SLM1606M_GREEN  0x10
#define SLM1606M_YELLOW 0x11
#define SLM1606M_OFF    0x00




#define     GLCD_COLOR_TABLE_BITS               2          // range 2 upto 6
#define     GLCD_COLOR_TABLE_COUNT              (1 << GLCD_COLOR_TABLE_BITS)
#define     GLCD_FONT_HEADER_SIZE               7
                                                
                                               
                                                
#define     L8(v)                               ((v>>0)&0xFF)
#define     H8(v)                               ((v>>8)&0xFF)
                                                
#define     GLCD_WAIT()                         nop++
//#define     GLCD_OUT(w)                         display[Cursorx][Cursory]=w;Cursorx++
#define     GLCD_OUT(w)                         set_pixel(Cursorx,Cursory,w);Cursorx++

#define     NONE                                0x00

#define     Font_Set_Window(a1, b1, a2, b2)       Font.Window.x1 = a1; Font.Window.y1 = b1; Font.Window.x2 = a2; Font.Window.y2 = b2



#ifdef __cplusplus
extern "C"
{
#endif
/*
// =============================================================================
//   types
// =============================================================================
*/


typedef unsigned short  glcdColor_t;
typedef unsigned char   glcdCoord_t;
typedef unsigned char*  glcdFontData_t;

typedef struct {
    glcdCoord_t x;
    glcdCoord_t y;
} glcdPoint_t;

typedef struct {
    glcdCoord_t x1;
    glcdCoord_t y1;
    glcdCoord_t x2;
    glcdCoord_t y2;
} glcdRect_t;

typedef union {
    unsigned char All;
    struct {
    unsigned char FixedFont:1,  // don't reorder
            LineFeed:1,
            VirtualFontRow:1;
    };
} glcdFlags_t;

typedef struct {
    glcdColor_t    Colors[GLCD_COLOR_TABLE_COUNT];
    glcdFlags_t    Flags;
    glcdPoint_t    Cursor;
    glcdRect_t     Window;
    unsigned char        FontCharSpace;
    unsigned char           FontFirstChar;//!!! nicht char sondern unsigend wenn letzter buchstabe grer 127, passiert ein fehler beim laden der rle
    unsigned char           FontLastChar;//!!! nicht char sondern unsigend
    unsigned char        FontWidth;
    unsigned char        FontHeight;
    unsigned char        FontBitsPixel;
    glcdFontData_t FontData;
    unsigned char        FontRLE[4];
    unsigned short      FontBitsHeight;
    unsigned char        Buf[10];
} glcdData_t;

extern glcdData_t Font;


void Font_Select_Font(const void* data);
void Font_Draw_Text(const unsigned char* text, unsigned short size, unsigned char flashstored,uint8_t color,uint8_t bgcolor,uint8_t mode);

#ifdef __cplusplus
}
#endif

#endif