


#include <inttypes.h>

#include "Font.h"
#include "Font_User.h"
#include "8_3x5.h"
#include "ArialFett8.h"
#include "Small5.h"
#include "Date_User.h"
#include "lcdg.h"

uint8_t Font_Month_X_Offset[12+1] ={0,14,11,18,19,21,19,21,13,2,10,4,4};


void Font_Show_Year(uint8_t x,uint8_t y,uint16_t year, uint8_t color)
{
    //lcdg_fillbox(20,59,46,68,SLM1606M_OFF);
    lcdg_fillbox(x,y+2,x+26,y+11,SLM1606M_OFF);
    Font_Select_Font(FONT_ArialFett8);
    //Font_Select_Font(FONT_8_3x5);

    Font.FontCharSpace=1;
    //Font.Flags.LineFeed=1;
    //Font.Flags.FixedFont=1;
    //Font.Flags.VirtualFontRow=1;

    Font.Colors[0]=0;
    Font.Colors[1]=1;
    
    Font.Cursor.x=x;
    Font.Cursor.y=y;
    Font.Buf[0]=(year/1000)|0x30;
    year%=1000;
    Font.Buf[1]=(year/100)|0x30;
    year%=100;
    Font.Buf[2]=(year/10)|0x30;
    year%=10;
    Font.Buf[3]=year|0x30;;
    Font.Buf[4]='\n';
    Font_Draw_Text(Font.Buf,5,0,color,0,0);
}


void Font_Show_Month(uint8_t x,uint8_t y,uint16_t month, uint8_t color)
{
    lcdg_fillbox(x,y+1,x+63,y+11,SLM1606M_OFF);
    Font_Select_Font(FONT_ArialFett8);
    //Font_Select_Font(FONT_8_3x5);

    Font.FontCharSpace=1;
    //Font.Flags.LineFeed=1;
    //Font.Flags.FixedFont=1;
    //Font.Flags.VirtualFontRow=1;
    
    Font.Colors[0]=0;
    Font.Colors[1]=1;

    if(month>12)
        month=1;
    Font.Cursor.x=Font_Month_X_Offset[month]+x;
    Font.Cursor.y=y;
    Font_Draw_Text(Date_Get_Month_Text_Pointer(month),10,0,color,0,0);
}

void Font_Write_Char(uint8_t x, uint8_t y, uint8_t color,uint8_t bgcolor,char letter,uint8_t mode)
{
    Font_Select_Font(FONT_Small5);

    Font.FontCharSpace=1;
    //Font.Flags.LineFeed=1;
    //Font.Flags.FixedFont=1;
    //Font.Flags.VirtualFontRow=1;

    Font.Colors[0]=0;
    Font.Colors[1]=1;
    
    Font.Cursor.x=x;
    Font.Cursor.y=y;
    Font.Buf[0]=letter;
    Font.Buf[1]='\n';
    Font_Draw_Text(Font.Buf,1,0,color,bgcolor,mode);
}


