#include "Sced_Disp.h"
#include "Sced.h"
#include "Sced_Disp_If_Used.h"
#include "Date.h"
#include "Date_User.h"
#include "Font_User.h"
//Sced_Disp_Data_t Sced_Disp_Day_Row[SCED_DISP_DAYS_Y][SCED_DISP_DAYS_X];


#define SCED_DISP_X_BASE_POS        0
#define SCED_DISP_Y_BASE_POS        0

#define SCED_DISP_CALWEEKS_X_POS    SCED_DISP_X_BASE_POS
#define SCED_DISP_CALWEEKS_Y_POS    SCED_DISP_Y_BASE_POS

#define SCED_DISP_WEEKS_X_POS       SCED_DISP_X_BASE_POS
#define SCED_DISP_WEEKS_Y_POS       SCED_DISP_Y_BASE_POS+8

#define SCED_DISP_MONTH_X_POS       SCED_DISP_X_BASE_POS
#define SCED_DISP_MONTH_Y_POS       SCED_DISP_Y_BASE_POS+68

#define SCED_DISP_YEAR_X_POS        SCED_DISP_X_BASE_POS+20
#define SCED_DISP_YEAR_Y_POS        SCED_DISP_Y_BASE_POS+57




Sced_Disp_Weeks_t   Sced_Disp_Weeks;

Sced_Disp_Week_t    Sced_Disp_CalWeek;

//
/*
#define SCED_DISP_M_CALC_WEEK_POS(day)     (uint8_t)((((g_offset+(day-1))/SCED_DISP_DAYS_X)^0xFF)+SCED_DISP_DAYS_Y)
#define SCED_DISP_M_CALC_DAY_POS(day)      (uint8_t)((g_offset+(day-1))%SCED_DISP_DAYS_X)
*/


#define SCED_DISP_M_CALC_WEEK_POS(cweek)     SCED_DISP_M_GET_WEEK_POS((g_offset+(cweek-1))/SCED_DISP_DAYS_X)
#define SCED_DISP_M_CALC_DAY_POS(cday)       (uint8_t)((g_offset+(cday-1))%SCED_DISP_DAYS_X)

#define SCED_DISP_M_GET_WEEK_POS(week)       (uint8_t)(SCED_DISP_DAYS_Y-1-week)   //((week^0xFF)+SCED_DISP_DAYS_Y)
//#define SCED_DISP_M_GET_WEEK_POS(week)       (uint8_t)week
#define SCED_DISP_M_GET_DAY_POS(day)         (uint8_t)day



uint8_t g_offset;//days to first displayed day
uint8_t g_days;   //days to

/*
   :                      :
   | .................... |
   |                      |
   |  --- g_offset ---- 1 |  0
   |                      |
   |  2  3  4  5  6  7  8 |  1
   |                      |
   |  9 10 11 12 13 14 15 |  2
   |                      |    SCED_DISP_DAYS_Y  (WEEK)
   | 16 17 18 19 20 21 22 |  3
   |                      |
   | 23 24 25 26 27 28 29 |  4
   |                      |
   | 30 31                |  5
   |..................... |
   :                      :

      0  1  2  3  4  5  6

      SCED_DISP_DAYS_X (DAY)
*/
uint8_t cur_tog=0, cur_onoff=0, cur_pos=1,cur_cpos=0;


//Funktion zum Schreiben der Nummern eines Kalenderblattes
void Sced_Disp_Draw_Number(uint8_t x, uint8_t y,uint8_t number,uint8_t mode, uint8_t color,uint8_t bgcolor)
{
    if (number)
    {
        //draw ones
        Sced_Disp_If_Used(x+4,
                          y,
                          (number%10)|0x30,
                          mode,
                          color,
                          bgcolor,
                          SCED_DISP_IF_USED_COM_CHAR);
        if(number/10)
        {
            Sced_Disp_If_Used(x,
                              y,
                              (number/10)|0x30,
                              mode,
                              color,
                              bgcolor,
                              SCED_DISP_IF_USED_COM_CHAR);
        }
        else
        {   
            if(mode)
            {
                Sced_Disp_If_Used(x,
                                  y,
                                  x+2,
                                  y+4,
                                  bgcolor,
                                  0x00,
                                  SCED_DISP_IF_USED_COM_FBOX);
            }
        }

    }
    else
    //if number == 0: draw 0 at ones (std function)
    {
        if(mode)
        {
            Sced_Disp_If_Used(x+4,
                          y,
                          0x30,
                          mode,
                          color,
                          bgcolor,
                          SCED_DISP_IF_USED_COM_CHAR);
        }

    }
}

void Sced_Disp_Draw_Char(uint8_t x, uint8_t y, uint8_t chara, uint8_t charb ,uint8_t color)
{
    Sced_Disp_If_Used(x   ,y,chara,0,color,0x00,SCED_DISP_IF_USED_COM_CHAR);
    Sced_Disp_If_Used(x+=4,y,charb,0,color,0x00,SCED_DISP_IF_USED_COM_CHAR);
}

void Sced_Disp_Draw_Weekday_Scale (uint8_t x, uint8_t y)
{
	uint8_t fontx,fonty;
    //draw
    Sced_Disp_If_Used(x,
                      y+50,
                      x+62,
                      y+50,
                      SCED_DISP_COL_WDLINE,
                      0x00,
                      SCED_DISP_IF_USED_COM_LINE);

    fonty=44+y;
    fontx=1+x;

    Sced_Disp_Draw_Char(fontx   ,fonty,'M','o',SCED_DISP_COL_SCALE);
    Sced_Disp_Draw_Char(fontx+=9,fonty,'D','i',SCED_DISP_COL_SCALE);
    Sced_Disp_Draw_Char(fontx+=9,fonty,'M','i',SCED_DISP_COL_SCALE);
    Sced_Disp_Draw_Char(fontx+=9,fonty,'D','o',SCED_DISP_COL_SCALE);
    Sced_Disp_Draw_Char(fontx+=9,fonty,'F','r',SCED_DISP_COL_SCALE);
    Sced_Disp_Draw_Char(fontx+=9,fonty,'S','a',SCED_DISP_COL_SCALE);
    Sced_Disp_Draw_Char(fontx+=9,fonty,'S','o',SCED_DISP_COL_SCALE);

    Sced_Disp_If_Used(x,
                      y+42,
                      x+62,
                      y+42,
                      SCED_DISP_COL_WDLINE,
                      0x00,
                      SCED_DISP_IF_USED_COM_LINE);
}
void Sced_Disp_Draw_CalWeek_Scale (uint8_t x, uint8_t y)
{
	uint8_t fontx,fonty;
    //draw line
    Sced_Disp_If_Used(x,
                      y+7,
                      x+62,
                      y+7,
                      SCED_DISP_COL_CWLINE,
                      0x00,
                      SCED_DISP_IF_USED_COM_LINE);

    fonty=1+y;
    fontx=x;

    Sced_Disp_Draw_Char(fontx   ,fonty,'K','W',SCED_DISP_COL_CWSCALE);
    Sced_Disp_If_Used(fontx+=7,fonty,':',0,SCED_DISP_COL_CWSCALE,0x00,SCED_DISP_IF_USED_COM_CHAR);
}

void Sced_Disp_Draw_Day(uint8_t x, uint8_t y,Sced_Disp_Day_t * p_Day)
{

    uint8_t bgcolor,curcolor;
    if(p_Day->Update)
    {
        p_Day->Update=0;

        if(p_Day->Fill_High)
        {
            bgcolor=SCED_DISP_COL_RED;
            Sced_Disp_If_Used(x+4,
                              y+1,
                              x+4,
                              y+5,
                              SCED_DISP_COL_RED,
                              0x00,
                              SCED_DISP_IF_USED_COM_LINE);
        }
        else if (p_Day->Fill_Mid)
        {
            bgcolor=SCED_DISP_COL_YELLOW;
            Sced_Disp_If_Used(x+4,
                              y+1,
                              x+4,
                              y+5,
                              SCED_DISP_COL_YELLOW,
                              0x00,
                              SCED_DISP_IF_USED_COM_LINE);
        }
        else if (p_Day->Fill_Low)
        {
            bgcolor=SCED_DISP_COL_GREEN;
            Sced_Disp_If_Used(x+4,
                              y+1,
                              x+4,
                              y+5,
                              SCED_DISP_COL_GREEN,
                              0x00,
                              SCED_DISP_IF_USED_COM_LINE);
        }else
        {
            bgcolor=SCED_DISP_COL_OFF;
            Sced_Disp_If_Used(x+4,
                              y+1,
                              x+4,
                              y+5,
                              SCED_DISP_COL_OFF,
                              0x00,
                              SCED_DISP_IF_USED_COM_LINE);
        }




        if(p_Day->Frame_High|p_Day->Fill_High)
        {
            Sced_Disp_If_Used(x,
                              y,
                              x+8,
                              y+6,
                              SCED_DISP_COL_RED,
                              0x00,
                              SCED_DISP_IF_USED_COM_BOX);
        }
        else if (p_Day->Frame_Mid|p_Day->Fill_Mid)
        {
            Sced_Disp_If_Used(x,
                              y,
                              x+8,
                              y+6,
                              SCED_DISP_COL_YELLOW,
                              0x00,
                              SCED_DISP_IF_USED_COM_BOX);
        }
        else if (p_Day->Frame_Low|p_Day->Fill_Low)
        {
            Sced_Disp_If_Used(x,
                              y,
                              x+8,
                              y+6,
                              SCED_DISP_COL_GREEN,
                              0x00,
                              SCED_DISP_IF_USED_COM_BOX);
        }
        else
        {
            Sced_Disp_If_Used(x,
                              y,
                              x+8,
                              y+6,
                              SCED_DISP_COL_OFF,
                              0x00,
                              SCED_DISP_IF_USED_COM_BOX);

        }


        /*if(p_Day->Fill_Hight)
        {
            Sced_Disp_If_Used(x+4,
                              y+6,
                              0,
                              0,
                              SCED_DISP_COL_RED,
                              0x00,
                              SCED_DISP_IF_USED_COM_PIXEL);
        }*/
        if (p_Day->Fill_Mid)
        {
            Sced_Disp_If_Used(x+5,
                              y+6,
                              0,
                              0,
                              SCED_DISP_COL_YELLOW,
                              0x00,
                              SCED_DISP_IF_USED_COM_PIXEL);
        }
        if (p_Day->Fill_Low)
        {
            Sced_Disp_If_Used(x+6,
                              y+6,
                              0,
                              0,
                              SCED_DISP_COL_GREEN,
                              0x00,
                              SCED_DISP_IF_USED_COM_PIXEL);
        }


        /*if(p_Day->Frame_High)
        {
            Sced_Disp_If_Used(x+0,
                              y+6,
                              0,
                              0,
                              SCED_DISP_COL_RED,
                              0x00,
                              SCED_DISP_IF_USED_COM_PIXEL);
        }*/
        if (p_Day->Frame_Mid)
        {
            Sced_Disp_If_Used(x+3,
                              y+6,
                              0,
                              0,
                              SCED_DISP_COL_YELLOW,
                              0x00,
                              SCED_DISP_IF_USED_COM_PIXEL);
        }
        if (p_Day->Frame_Low)
        {
            Sced_Disp_If_Used(x+2,
                              y+6,
                              0,
                              0,
                              SCED_DISP_COL_GREEN,
                              0x00,
                              SCED_DISP_IF_USED_COM_PIXEL);
        }


        if((p_Day->Frame_High)&&(p_Day->Fill_High))
        {
            Sced_Disp_If_Used(x+4,
                              y+6,
                              0,
                              0,
                              SCED_DISP_COL_OFF,
                              0x00,
                              SCED_DISP_IF_USED_COM_PIXEL);
        }    
        else if((p_Day->Frame_Mid)&&(p_Day->Fill_Mid))
        {
            Sced_Disp_If_Used(x+3,
                              y+6,
                              0,
                              0,
                              SCED_DISP_COL_OFF,
                              0x00,
                              SCED_DISP_IF_USED_COM_PIXEL);
        }
        else if((p_Day->Frame_Low)&&(p_Day->Fill_Low))
        {
            Sced_Disp_If_Used(x+2,
                              y+6,
                              0,
                              0,
                              SCED_DISP_COL_OFF,
                              0x00,
                              SCED_DISP_IF_USED_COM_PIXEL);
        }

        if(p_Day->Fill_High||p_Day->Frame_High)
        {
            curcolor=SCED_DISP_COL_OFF;
        }
        else
        {
            curcolor=SCED_DISP_COL_CURSOR;
        }
        //draw cusor
        if(p_Day->Cursor)
        {
            Sced_Disp_If_Used(x+0,y+0,0,0,curcolor,0,SCED_DISP_IF_USED_COM_PIXEL);
            Sced_Disp_If_Used(x+1,y+0,0,0,curcolor,0,SCED_DISP_IF_USED_COM_PIXEL);
            Sced_Disp_If_Used(x+0,y+1,0,0,curcolor,0,SCED_DISP_IF_USED_COM_PIXEL);
    
            Sced_Disp_If_Used(x+0,y+6,0,0,curcolor,0,SCED_DISP_IF_USED_COM_PIXEL);
            Sced_Disp_If_Used(x+1,y+6,0,0,curcolor,0,SCED_DISP_IF_USED_COM_PIXEL);
            Sced_Disp_If_Used(x+0,y+5,0,0,curcolor,0,SCED_DISP_IF_USED_COM_PIXEL);

            Sced_Disp_If_Used(x+8,y+0,0,0,curcolor,0,SCED_DISP_IF_USED_COM_PIXEL);
            Sced_Disp_If_Used(x+7,y+0,0,0,curcolor,0,SCED_DISP_IF_USED_COM_PIXEL);
            Sced_Disp_If_Used(x+8,y+1,0,0,curcolor,0,SCED_DISP_IF_USED_COM_PIXEL);

            Sced_Disp_If_Used(x+8,y+6,0,0,curcolor,0,SCED_DISP_IF_USED_COM_PIXEL);
            Sced_Disp_If_Used(x+7,y+6,0,0,curcolor,0,SCED_DISP_IF_USED_COM_PIXEL);
            Sced_Disp_If_Used(x+8,y+5,0,0,curcolor,0,SCED_DISP_IF_USED_COM_PIXEL);
        }


        if(p_Day->Day)
        {
            if(bgcolor!=SCED_DISP_COL_OFF)
            {
                //draw inverted number
                Sced_Disp_Draw_Number(x+1,
                                        y+1,
                                        p_Day->Day,
                                        0x01,               //select 1 (draw background) mode
                                        SCED_DISP_COL_OFF,  //switch off text (iverse function)
                                        bgcolor);           //get bg color from fill marc setting bits
            }
            else
            {
                //draw normal number with daycolor and off backgrond
                Sced_Disp_Draw_Number(x+1,
                                        y+1,
                                        p_Day->Day,
                                        0x01,               //select 1 (draw background) mode
                                        p_Day->Day_Color,   //get normal day color 
                                        SCED_DISP_COL_OFF); //switch backgrond off
            }

        }
        else
        {
            //switch off the hole day field
            Sced_Disp_If_Used(x,
                              y,
                              x+8,
                              y+6,
                              SCED_DISP_COL_OFF,
                              0x00,
                              SCED_DISP_IF_USED_COM_FBOX);

        }
    }
}

void Sced_Disp_Draw_Week(uint8_t x, uint8_t y,Sced_Disp_Week_t * p_Week)
{
    uint8_t cnt_day=0;
    while(cnt_day<SCED_DISP_DAYS_X)
    {
        Sced_Disp_Draw_Day(x+(cnt_day*9),y,&p_Week->Day[cnt_day]);
        cnt_day++;
    }
}
void Sced_Disp_Draw_Weeks(uint8_t x, uint8_t y,Sced_Disp_Weeks_t * p_Weeks)
{
    uint8_t cnt_week=0;
    while(cnt_week<SCED_DISP_DAYS_Y)
    {
        Sced_Disp_Draw_Week(x,y+((SCED_DISP_DAYS_Y-1-cnt_week)*7),&p_Weeks->Week[SCED_DISP_M_GET_WEEK_POS(cnt_week)]);
        cnt_week++;
    }
}
//sets the color of one week in cal
void Sced_Disp_Set_Week_Day_Color(Sced_Disp_Week_t * p_Week)
{
    uint8_t cnt_day=0;
    while(cnt_day<SCED_DISP_DAYS_X)
    {
        switch(cnt_day)
        {
            case SCED_DAY_MO:
            case SCED_DAY_TU:                
            case SCED_DAY_MI:
            case SCED_DAY_TH:                
            case SCED_DAY_FR:
            {
                //green
                p_Week->Day[cnt_day].Day_Color=SCED_DISP_COL_WEEKDAY;
                break;
            }
            case SCED_DAY_SA:
            {
                //yellow
                p_Week->Day[cnt_day].Day_Color=SCED_DISP_COL_SATURDAY;
                break;
            }                
            case SCED_DAY_SU: 
            {
                //red
                p_Week->Day[cnt_day].Day_Color=SCED_DISP_COL_SUNDAY;
                break;
            }               
        }
        cnt_day++;
    }
}
//sets the day color of the hole weeks in cal
void Sced_Disp_Set_Weeks_Day_Color(Sced_Disp_Weeks_t * p_Weeks)
{
    uint8_t cnt_week=0;
    while(cnt_week<SCED_DISP_DAYS_Y)
    {
        Sced_Disp_Set_Week_Day_Color(&p_Weeks->Week[cnt_week]);
        cnt_week++;
    }
}





void Sced_Disp_Gen_Calendar(void)
{
    
}
//fill in week numbers
void Sced_Disp_Set_Weeks_Rel(uint8_t days,uint8_t offset)
{
    uint8_t cnt_week=0;
    uint8_t cnt_day=0;
    uint8_t cnt_abs=0;
    offset%=7;

    g_offset=offset;
    g_days=days;
    //set weeks
    while(cnt_week<SCED_DISP_DAYS_Y)
    {
        cnt_day=0;
        while(cnt_day<SCED_DISP_DAYS_X)
        {

            if((cnt_abs<(days+offset))&&(cnt_abs>=offset))
            {
                Sced_Disp_Weeks.Week[SCED_DISP_M_GET_WEEK_POS(cnt_week)].Day[SCED_DISP_M_GET_DAY_POS(cnt_day)].Day=cnt_abs-offset+1;
            }
            else
            {
                Sced_Disp_Weeks.Week[SCED_DISP_M_GET_WEEK_POS(cnt_week)].Day[SCED_DISP_M_GET_DAY_POS(cnt_day)].Day=0;
            }
            Sced_Disp_Weeks.Week[SCED_DISP_M_GET_WEEK_POS(cnt_week)].Day[SCED_DISP_M_GET_DAY_POS(cnt_day)].Update=1;
            /*
            if(cnt_abs>=(days+offset))
            {
                Sced_Disp_Weeks.Week[cnt_week-1].Day[cnt_day].Day=0;
            }
            if(cnt_abs<offset)
            {
                Sced_Disp_Weeks.Week[cnt_week-1].Day[cnt_day].Day=0;
            }*/
            cnt_day++;
            cnt_abs++;
        }
        cnt_week++;
    }
}
void Sced_Disp_Show_Weeks_Rel(uint8_t days,uint8_t offset)
{
    //fill in week numbers
    Sced_Disp_Set_Weeks_Rel(days,offset);
    //display/update weeks
    Sced_Disp_Draw_Weeks(SCED_DISP_WEEKS_X_POS,SCED_DISP_WEEKS_Y_POS,&Sced_Disp_Weeks);
}
//set weekday color of cal week
void Sced_Disp_Set_CalWeek_Day_Color(Sced_Disp_Week_t * p_Week)
{
    uint8_t cnt_day=0;
    while(cnt_day<SCED_DISP_DAYS_Y)
    {
        p_Week->Day[cnt_day].Day_Color=SCED_DISP_COL_CALWEEK;
        cnt_day++;
    }
}
//fill in week numbers
//                          first displayed week, number of weeks, end week (1 or 53) 
void Sced_Disp_Set_CalWeek_Rel(uint8_t start_week,uint8_t numb, uint8_t end_week)
{
    uint8_t cnt_day=0;

    if((start_week==52)||(start_week==53))
    {
        while(cnt_day<(SCED_DISP_DAYS_X-1))
        {
            if(cnt_day<numb)
            {
                Sced_Disp_CalWeek.Day[cnt_day].Day=start_week+cnt_day;
                Sced_Disp_CalWeek.Day[cnt_day].Update=1;
                if((start_week==52)||(start_week==53))
                {
                     start_week=0;                       
                }
            }
            else
            {
                //switch off day
                Sced_Disp_CalWeek.Day[cnt_day].Day=0;
                Sced_Disp_CalWeek.Day[cnt_day].Update=1;
            }
            cnt_day++;
        }
    }
    else
    {
        while(cnt_day<(SCED_DISP_DAYS_X-1))
        {
            if(cnt_day<numb)
            {
                if(start_week+cnt_day==53)
                {
                    Sced_Disp_CalWeek.Day[cnt_day].Day=end_week;
                    Sced_Disp_CalWeek.Day[cnt_day].Update=1;
                }
                else
                {
                    Sced_Disp_CalWeek.Day[cnt_day].Day=start_week+cnt_day;
                    Sced_Disp_CalWeek.Day[cnt_day].Update=1;
                }
            }
            else
            {
                //switch off day
                Sced_Disp_CalWeek.Day[cnt_day].Day=0;
                Sced_Disp_CalWeek.Day[cnt_day].Update=1;
            }
            cnt_day++;
        }
    }
}
void Sced_Disp_Show_CalWeek_Rel(uint8_t start_week,uint8_t numb,uint8_t end_week_bit)
{
    //fill in week numbers
    Sced_Disp_Set_CalWeek_Rel(start_week,numb,end_week_bit);
    //display/update calendar week
    Sced_Disp_Draw_Week(SCED_DISP_CALWEEKS_X_POS+9,SCED_DISP_CALWEEKS_Y_POS,&Sced_Disp_CalWeek);
}

void Sced_Disp_Update_Weeks (void)
{
    Sced_Disp_Draw_Weeks(SCED_DISP_WEEKS_X_POS,SCED_DISP_WEEKS_Y_POS,&Sced_Disp_Weeks);
}

void Sced_Disp_Update_CalWeek (void)
{
     Sced_Disp_Draw_Week(SCED_DISP_CALWEEKS_X_POS+9,SCED_DISP_CALWEEKS_Y_POS,&Sced_Disp_CalWeek);
}

//Marc fuction

void Sced_Disp_Copy_Marc(Sced_Disp_Day_t * p_Day, Sced_Disp_Marc_t * p_marc)
{
   p_Day->Frame_High=p_marc->Frame_High;
   p_Day->Frame_Mid=p_marc->Frame_Mid;
   p_Day->Frame_Low=p_marc->Frame_Low;
   p_Day->Fill_High=p_marc->Fill_High;
   p_Day->Fill_Mid=p_marc->Fill_Mid;
   p_Day->Fill_Low=p_marc->Fill_Low;  
   p_Day->Cursor=p_marc->Cursor;
   p_Day->Update=1;
}
//copies just the mask marc bits 
void Sced_Disp_Copy_Mask_Marc(Sced_Disp_Day_t * p_Day, Sced_Disp_Marc_t * p_marc,uint8_t mask)
{
   if(mask&SCED_DISP_MARC_MASK_FRAME_H)
   {
        p_Day->Frame_High=p_marc->Frame_High;
   }
   if(mask&SCED_DISP_MARC_MASK_FRAME_M)
   {
        p_Day->Frame_Mid=p_marc->Frame_Mid;
   }
   if(mask&SCED_DISP_MARC_MASK_FRAME_L)
   {
        p_Day->Frame_Low=p_marc->Frame_Low;
   }
   if(mask&SCED_DISP_MARC_MASK_FILL_H)
   {
        p_Day->Fill_High=p_marc->Fill_High;
   }
   if(mask&SCED_DISP_MARC_MASK_FILL_M)
   {
        p_Day->Fill_Mid=p_marc->Fill_Mid;
   }
   if(mask&SCED_DISP_MARC_MASK_FILL_L)
   {
        p_Day->Fill_Low=p_marc->Fill_Low;  
   }
   if(mask&SCED_DISP_MARC_MASK_CURSOR)
   {
        p_Day->Cursor=p_marc->Cursor;
   }
   p_Day->Update=1;
}
void Sced_Disp_Set_Marc_Direct( Sced_Disp_Marc_t * p_marc,uint8_t directval)
{
   Sced_Disp_Marc_t * p_zeromarc;
   p_zeromarc=(Sced_Disp_Marc_t *)&directval;
   *p_marc=*p_zeromarc;
}
/*old
uint8_t Sced_Disp_Weeks_Get_Day_Pos_Rel(Sced_Disp_Weeks_t * p_Weeks,uint8_t Day, uint8_t * WeekPos, uint8_t * DayPos)
{
    uint8_t cnt_week=0;
    uint8_t cnt_day=0;

    //search day position 
    while(cnt_week<SCED_DISP_DAYS_Y)
    {
        cnt_day=0;
        while(cnt_day<SCED_DISP_DAYS_X)
        {
            if(p_Weeks->Week[cnt_week].Day[cnt_day].Day==Day)
            {
                    *DayPos=cnt_day;
                    *WeekPos=cnt_week;
                    return 1;
            }
            cnt_day++;
        }
        cnt_week++;
    }
    return 0;
}

uint8_t Sced_Disp_Set_Day_Marc_Rel(uint8_t Day, Sced_Disp_Marc_t * p_marc)
{
    uint8_t DayPos=0;
    uint8_t WeekPos=0;

    if(Sced_Disp_Weeks_Get_Day_Pos_Rel(&Sced_Disp_Weeks,Day,&WeekPos,&DayPos))
    {
        Sced_Disp_Copy_Marc(&Sced_Disp_Weeks.Week[WeekPos].Day[DayPos],p_marc);
        //Sced_Disp_Weeks.Week[WeekPos].Day[DayPos].Update=1;
        return 1;
    }
    return 0;   
}*/

uint8_t Sced_Disp_Set_Day_Marc_Rel(uint8_t Day, Sced_Disp_Marc_t * p_marc)
{
    if(Day&&(Day<=g_days))
        Sced_Disp_Copy_Marc(&Sced_Disp_Weeks.Week[SCED_DISP_M_CALC_WEEK_POS(Day)].Day[SCED_DISP_M_CALC_DAY_POS(Day)],p_marc);
    return 1;
}
uint8_t Sced_Disp_Set_Mask_Day_Marc_Rel(uint8_t Day, Sced_Disp_Marc_t * p_marc,uint8_t mask)
{
    if(Day&&(Day<=g_days))
        Sced_Disp_Copy_Mask_Marc(&Sced_Disp_Weeks.Week[SCED_DISP_M_CALC_WEEK_POS(Day)].Day[SCED_DISP_M_CALC_DAY_POS(Day)],p_marc,mask);
    return 1;
}
void Sced_Disp_Reset_Day_Marcs(void)
{

}

//returns 0 if all days of a week are zero
uint8_t Sced_Disp_Get_Week_Days_Not_Zero(Sced_Disp_Week_t * p_Week)
{
    uint8_t cnt_day=0;

    while(cnt_day<SCED_DISP_DAYS_X)
    {
        if(p_Week->Day[cnt_day].Day>0)
        {
            return 1;
        }
        cnt_day++;
    }
    return 0;

}
//open
//returns how many weeks having a valid day entry
uint8_t Sced_Disp_Get_Valid_Week_Day_Not_Zero_Count(void)
{ 
    uint8_t cnt_week=0;
    uint8_t cnt_valid=0;
    //search day position 
    while(cnt_week<SCED_DISP_DAYS_Y)
    {
        if(Sced_Disp_Get_Week_Days_Not_Zero(&Sced_Disp_Weeks.Week[cnt_week]))
        {
            cnt_valid++;
        }
        cnt_week++;
    }
    return cnt_valid;
}
//returns the week index of the week located the first found marc
uint8_t Sced_Disp_Get_Week_With_Day_Marc (Sced_Disp_Marc_t * p_marc)
{
    uint8_t cnt_week=0;
    uint8_t cnt_day=0;
    Sced_Disp_Weeks_t * p_Weeks;
    p_Weeks=&Sced_Disp_Weeks;
    //search day position 
    while(cnt_week<SCED_DISP_DAYS_Y)
    {
        cnt_day=0;
        while(cnt_day<SCED_DISP_DAYS_X)
        {
            if(p_marc->Frame_High&&p_Weeks->Week[SCED_DISP_M_GET_WEEK_POS(cnt_week)].Day[cnt_day].Frame_High)
            {
               return cnt_week;
            }
            if(p_marc->Frame_Mid&&p_Weeks->Week[SCED_DISP_M_GET_WEEK_POS(cnt_week)].Day[cnt_day].Frame_Mid)
            {
               return cnt_week;
            }
            if(p_marc->Frame_Low&&p_Weeks->Week[SCED_DISP_M_GET_WEEK_POS(cnt_week)].Day[cnt_day].Frame_Low)
            {
               return cnt_week;
            }
            
            if(p_marc->Fill_High&&p_Weeks->Week[SCED_DISP_M_GET_WEEK_POS(cnt_week)].Day[cnt_day].Fill_High)
            {
               return cnt_week;
            }
            if(p_marc->Fill_Mid&&p_Weeks->Week[SCED_DISP_M_GET_WEEK_POS(cnt_week)].Day[cnt_day].Fill_Mid)
            {
               return cnt_week;
            }
            if(p_marc->Fill_Low&&p_Weeks->Week[SCED_DISP_M_GET_WEEK_POS(cnt_week)].Day[cnt_day].Fill_Low)
            {
               return cnt_week;
            }

            cnt_day++;
        }
        cnt_week++;
    }
    return 0;
}
void Sced_Disp_Set_Week_Marc(uint8_t week,Sced_Disp_Marc_t * p_marc)
{
   if(week<SCED_DISP_DAYS_Y)
   {
       Sced_Disp_Copy_Marc(&Sced_Disp_CalWeek.Day[week],p_marc);
       //Sced_Disp_CalWeek.Day[week].Update=1;
   }
} 
void Sced_Disp_Show_Month (uint8_t month,uint8_t update)
{
    static uint8_t last_month=0;
    if((update&SCED_DISP_UPDATE_ALL)||((last_month!=month)&&(update&SCED_DISP_UPDATE_ALL_NESS)))
    {
        Sced_Disp_If_Used(SCED_DISP_MONTH_X_POS,
                      SCED_DISP_MONTH_Y_POS,
                      month,
                      0,
                      SCED_DISP_COL_MONTH,
                      0x00,
                      SCED_DISP_IF_USED_COM_MONTH);
        last_month=month;
    }
}
void Sced_Disp_Show_Year (uint16_t year,uint8_t update)
{
    static uint16_t last_year=0;
    if((update&SCED_DISP_UPDATE_ALL)||((last_year!=year)&&(update&SCED_DISP_UPDATE_ALL_NESS)))
    {
        Sced_Disp_If_Used(SCED_DISP_YEAR_X_POS,
                      SCED_DISP_YEAR_Y_POS,
                      year&0xFF,
                      (year>>8)&0xFF,
                      SCED_DISP_COL_YEAR,
                      0x00,
                      SCED_DISP_IF_USED_COM_YEAR);
        last_year=year;
    }
}

//user
void Sced_Disp_Set_Cal_Rel(uint8_t days, uint8_t offset, uint8_t week, uint8_t end_week)
{
    //fill display with days / 
    Sced_Disp_Set_Weeks_Rel(days,offset);

    Sced_Disp_Set_CalWeek_Rel(week,
                              Sced_Disp_Get_Valid_Week_Day_Not_Zero_Count(),  //for displaying calendar weeks 4,5 or 6
                              end_week);
}

void Sced_Disp_Set_Actual_Day_Marc(uint8_t day)
{
   volatile static uint8_t last_day=0,week=0;
   Sced_Disp_Marc_t day_marc,calweek_marc;

   //frame day
   Sced_Disp_Set_Marc_Direct(&day_marc,0);          //set marc mem to 0
   Sced_Disp_Set_Day_Marc_Rel(last_day,&day_marc);  //reset old daymarc - param:day , marc kind
   last_day=day;                                    //remember actual day
   day_marc.Frame_High=1;                           //select red frame
   Sced_Disp_Set_Day_Marc_Rel(day,&day_marc);       //set actual day marc - param:day , marc kind

   //frame calendar week
   Sced_Disp_Set_Marc_Direct(&calweek_marc,0);      //set marc mem to 0
   Sced_Disp_Set_Week_Marc(week,
                           &calweek_marc);          //reset old week marc
   week=Sced_Disp_Get_Week_With_Day_Marc(&day_marc);//get week in that the day is (found over daymarc)
   calweek_marc.Frame_Low=1;                        //set marc bit (green frame)
   Sced_Disp_Set_Week_Marc(week,
                           &calweek_marc);          //set calendar week marc depending on marced day
}
//Init: Set Colors and position 

//update

//generate

void Sced_Disp_Init(void)
{

    //fill in the typical color look of the calendar weekdays
    Sced_Disp_Set_Weeks_Day_Color(&Sced_Disp_Weeks);
    //
    Sced_Disp_Set_CalWeek_Day_Color(&Sced_Disp_CalWeek);
 
}
void Sced_Redraw_Face (void)
{
    Sced_Disp_Draw_Weekday_Scale(SCED_DISP_WEEKS_X_POS,SCED_DISP_WEEKS_Y_POS);

    Sced_Disp_Draw_CalWeek_Scale(SCED_DISP_CALWEEKS_X_POS,SCED_DISP_CALWEEKS_Y_POS);
}
void Sced_Disp_Show_Date(date_t * p_date,uint8_t update)
{
    //static uint16_t year=0;
    //static uint16_t month=0;
     
    Sced_Disp_Marc_t marc;
    if(Date_Check_Date(p_date))
    {

        Sced_Disp_Set_Cal_Rel(  Date_Calc_MaxDay(p_date),
                                Date_Calc_Get_First_Day_In_Month(p_date),
                                Date_Calc_Get_First_Week_In_Month(p_date),
                                Date_Calc_Get_Last_Week_In_Year(p_date));  //days,dayoffset,start calweek,endweek(just53)
        
        Sced_Disp_Set_Actual_Day_Marc(p_date->day);
                //Sced_Disp_Set_Actual_Day_Marc(8);
                //Sced_Disp_Set_Actual_Day_Marc(12);
                //Sced_Disp_Set_Actual_Day_Marc(13);
        /*
        Sced_Disp_Set_Marc_Direct(&marc,SCED_DISP_MARC_MASK_FILL_M);//fill marc with a 8 bit value direct

        Sced_Disp_Set_Mask_Day_Marc_Rel(4,&marc,SCED_DISP_MARC_MASK_FILL_M);
        Sced_Disp_Set_Mask_Day_Marc_Rel(10,&marc,SCED_DISP_MARC_MASK_FILL_M);

        Sced_Disp_Set_Marc_Direct(&marc,SCED_DISP_MARC_MASK_FILL_H);//fill marc with a 8 bit value direct

        Sced_Disp_Set_Mask_Day_Marc_Rel(14,&marc,SCED_DISP_MARC_MASK_FILL_H);
        Sced_Disp_Set_Mask_Day_Marc_Rel(15,&marc,SCED_DISP_MARC_MASK_FILL_H);
        Sced_Disp_Set_Mask_Day_Marc_Rel(21,&marc,SCED_DISP_MARC_MASK_FILL_H);
        Sced_Disp_Set_Mask_Day_Marc_Rel(6,&marc,SCED_DISP_MARC_MASK_FILL_H);

        Sced_Disp_Set_Marc_Direct(&marc,SCED_DISP_MARC_MASK_FILL_L);//fill marc with a 8 bit value direct

        Sced_Disp_Set_Mask_Day_Marc_Rel(24,&marc,SCED_DISP_MARC_MASK_FILL_L);
        */

//Sced_Disp_Set_Weeks_Rel(31,0);
/*
Sced_Disp_Set_Marc_Direct(&marc,SCED_DISP_MARC_MASK_FRAME_H|SCED_DISP_MARC_MASK_FILL_M);//fill marc with a 8 bit value direct

Sced_Disp_Set_Day_Marc_Rel(p_date->day-0,&marc);//set day marc

Sced_Disp_Set_Marc_Direct(&marc,0x38);//fill marc with a 8 bit value direct

Sced_Disp_Set_Day_Marc_Rel(p_date->day-2,&marc);//set day marc

Sced_Disp_Set_Marc_Direct(&marc,0x10);//fill marc with a 8 bit value direct

Sced_Disp_Set_Day_Marc_Rel(p_date->day-3,&marc);//set day marc

Sced_Disp_Set_Marc_Direct(&marc,0x11);//fill marc with a 8 bit value direct

Sced_Disp_Set_Day_Marc_Rel(p_date->day-4,&marc);//set day marc

Sced_Disp_Set_Marc_Direct(&marc,0x22);//fill marc with a 8 bit value direct

Sced_Disp_Set_Day_Marc_Rel(p_date->day-5,&marc);//set day marc

Sced_Disp_Set_Marc_Direct(&marc,0x00);//fill marc with a 8 bit value direct

Sced_Disp_Set_Day_Marc_Rel(p_date->day-6,&marc);//set day marc
      
Sced_Disp_Set_Marc_Direct(&marc,0x01);//fill marc with a 8 bit value direct

Sced_Disp_Set_Day_Marc_Rel(24,&marc);//set day marc
 */        
        Sced_Disp_Update_Weeks();

        Sced_Disp_Update_CalWeek();

        //if(p_date->month!=month)
            Sced_Disp_Show_Month(p_date->month,update);
        //month=p_date->month;

        //if(p_date->year!=year)
            Sced_Disp_Show_Year(p_date->year,update);
        //year=p_date->year;

    }
}
void Sced_Disp_Toggle_Cursor_Old(uint8_t day)
{
    Sced_Disp_Marc_t marc;    
    static uint8_t toggle=0;
    static uint8_t last_day=0;

    if(day==last_day)
    {
        if(toggle)
        {
            Sced_Disp_Set_Marc_Direct(&marc,0x40);//fill marc with a 8 bit value direct
            toggle=0;
        }
        else
        {
            Sced_Disp_Set_Marc_Direct(&marc,0x00);//fill marc with a 8 bit value direct
            toggle=1;
        }
        Sced_Disp_Set_Mask_Day_Marc_Rel(day,&marc,SCED_DISP_MARC_MASK_CURSOR);//set day marc
    }
    else
    {
        //reset old marc
        Sced_Disp_Set_Marc_Direct(&marc,0x00);//fill marc with a 8 bit value direct
        Sced_Disp_Set_Mask_Day_Marc_Rel(last_day,&marc,SCED_DISP_MARC_MASK_CURSOR);//set day marc
        //set new marc
        Sced_Disp_Set_Marc_Direct(&marc,0x40);//fill marc with a 8 bit value direct
        toggle=0;
        Sced_Disp_Set_Mask_Day_Marc_Rel(day,&marc,SCED_DISP_MARC_MASK_CURSOR);//set day marc

    }

    Sced_Disp_Update_Weeks();
    last_day=day;

}
void Sced_Disp_Cursor_Toggle(void)
{
    Sced_Disp_Marc_t marc; 
    static uint8_t curpos=0;
    static uint8_t curoff=0;
    if(cur_onoff)
    {
        //generates just one cursor clear after switching off the cursor
        curoff=1;
        if(cur_cpos)
        {
            cur_cpos=0;
            //switch off old cursor
            Sced_Disp_Set_Marc_Direct(&marc,0x00);//fill marc with a 8 bit value direct
            Sced_Disp_Set_Mask_Day_Marc_Rel(curpos,&marc,SCED_DISP_MARC_MASK_CURSOR);//set day marc
            //get new position
            curpos=cur_pos;
            //siwtch on cursor
            cur_tog=0;
        }

        if(cur_tog)
        {
            cur_tog=0;
            //switch off cursor
            Sced_Disp_Set_Marc_Direct(&marc,0x00);//fill marc with a 8 bit value direct
            Sced_Disp_Set_Mask_Day_Marc_Rel(curpos,&marc,SCED_DISP_MARC_MASK_CURSOR);//set day marc
            //get new position after cursor is off
        }
        else
        {
            cur_tog=1;
            Sced_Disp_Set_Marc_Direct(&marc,0x40);//fill marc with a 8 bit value direct
            Sced_Disp_Set_Mask_Day_Marc_Rel(curpos,&marc,SCED_DISP_MARC_MASK_CURSOR);//set day marc
        }
    }
    else
    {
        if(curoff)
        {
            curoff=0;
            Sced_Disp_Set_Marc_Direct(&marc,0x00);//fill marc with a 8 bit value direct
            Sced_Disp_Set_Mask_Day_Marc_Rel(curpos,&marc,SCED_DISP_MARC_MASK_CURSOR);//set day marc
        }
    }
    Sced_Disp_Update_Weeks();
}
//switch on/off cursor
void Sced_Disp_Cursor_Set(uint8_t val)
{
    cur_onoff=val;
    if(cur_onoff)
    {
        cur_cpos=1;//set change bit
    }
}
//change position
void Sced_Disp_Cursor_Set_Pos(uint8_t pos,date_t * p_date)
{

    uint8_t f_d_i_m=Date_Calc_Get_First_Day_In_Month(p_date);//first day in month

    switch(pos)
    {
        case '2'://down
        {
            cur_cpos=1;
            if(cur_pos<(31-6))
                cur_pos+=7;
        }
        break;
        case '8'://up
        {
            cur_cpos=1;
            if(cur_pos>7)
                cur_pos-=7;
        }
        break;
        case '4':
        {
            cur_cpos=1;
            if(((f_d_i_m+cur_pos-1)%7)==0)
                cur_pos+=7;
            if(cur_pos>1)
                cur_pos-=1;
        }
        break;
        case '6':
        {
            cur_cpos=1;
            if(((f_d_i_m+cur_pos)%7)==0)
                cur_pos-=7;
            if(cur_pos<31)
                cur_pos+=1;
        }
        break;
    }

}
uint8_t Sced_Disp_Cursor_Get_Pos (void)
{
    if(cur_pos<=31)
        return cur_pos;
    else
        return 1;

}
