/****************************************************************************/
/*                                                                  6.01.06 */
/* Grafikroutinen zur Ausgabe von Text und Pixel/Lines/Circle auf ein       */
/* Grafik-LCD.                                                              */
/*                                                                          */
/****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>


//#include "Led.h"
#include "lcdg.h"


//#include "ks0713.h"


/*===========================================================================*/

unsigned char lcdg_xpos; /* Merker fuer die Postion von Text auf dem Grafikscreen*/
unsigned char lcdg_ypos;

//void lcdg_init()
//{
//	ks0713_init();		/* Initialisiert das Grafikdisplay       */
//}

/*****************************************************************************/
/* Zeichnet ein Pixel in der gewuenschten Farbe                              */
/*****************************************************************************/
void lcdg_drawpixel(unsigned char x, unsigned char y, unsigned char color)
{  

   /* Diese Funktion ist Hardwarespezifisch*/
   /* Uebergabe an den Displayprozessor */

    SLM1606_setPixel( x, y, color);

}

void setPixel(int x , int y,int col)
{
    SLM1606_setPixel((unsigned char )x, (unsigned char) y, (unsigned char)col);
}

/*---------------------------------------------------------------------------*/
/* Ab hier nur hardwareunabhaengige Funktionen                               */
/*---------------------------------------------------------------------------*/

/*****************************************************************************/
/* Interne Hilfsroutine zum kreiszeichen, spiegelt die Segmente              */
/*****************************************************************************/

void circlepoints(unsigned int cx, unsigned int cy, unsigned int x,
                  unsigned int y, unsigned char color)
{
   if (x == 0) {
      lcdg_drawpixel(cx,cy+y, color);
      lcdg_drawpixel(cx,cy-y, color);
      lcdg_drawpixel(cx+y,cy, color);
      lcdg_drawpixel(cx-y,cy, color);
   } else
   if (x == y) {
      lcdg_drawpixel(cx+x,cy+y, color);
      lcdg_drawpixel(cx-x,cy+y, color);
      lcdg_drawpixel(cx+x,cy-y, color);
      lcdg_drawpixel(cx-x,cy-y, color);
   } else
   if (x<y) {
      lcdg_drawpixel(cx+x,cy+y, color);
      lcdg_drawpixel(cx-x,cy+y, color);
      lcdg_drawpixel(cx+x,cy-y, color);
      lcdg_drawpixel(cx-x,cy-y, color);
      lcdg_drawpixel(cx+y,cy+x, color);
      lcdg_drawpixel(cx-y,cy+x, color);
      lcdg_drawpixel(cx+y,cy-x, color);
      lcdg_drawpixel(cx-y,cy-x, color);
   }
}




/*****************************************************************************/
/* Zeichnet einen Kreis um die angebene Position                             */
/*****************************************************************************/

void lcdg_circle(unsigned char xCenter, unsigned char yCenter, 
                 unsigned char radius, unsigned char color)
{
   unsigned int x= 0;
   unsigned int y= radius;
   signed int p= (5- radius*4)/4;

   circlepoints(xCenter, yCenter, x, y, color);
   while (x<y) {
      x++;
      if (p<0) {
	 p += 2 * x + 1;
      } else {
	 y--;
	 p += 2 * (x-y)+1;
      }
      circlepoints(xCenter, yCenter, x, y, color);
   }
}

/*****************************************************************************/
/* Interne Hilfsroutine zum kreiszeichen, spiegelt die Segmente              */
/*****************************************************************************/

void circlelines(unsigned int cx, unsigned int cy, unsigned int x,
                  unsigned int y, unsigned char color)
{
   if (x == 0) {
      //GRF_drwline(cx,cy-y,cx,cy+y,color);
        GRF_drwline(cx-y,cy,cx+y,cy,color);
   } else
   if (x == y) {
      //lcdg_drawpixel(cx+x,cy+y, color);
      //lcdg_drawpixel(cx-x,cy+y, color);
      //lcdg_drawpixel(cx+x,cy-y, color);
      //lcdg_drawpixel(cx-x,cy-y, color);
        GRF_drwline(cx-x,cy-y,cx+x,cy-y,color);
        GRF_drwline(cx-x,cy+y,cx+x,cy+y,color);
   } else
   if (x<y) {
      //lcdg_drawpixel(cx+x,cy+y, color);
      //lcdg_drawpixel(cx-x,cy+y, color);
      //lcdg_drawpixel(cx+x,cy-y, color);
      //lcdg_drawpixel(cx-x,cy-y, color);

      //lcdg_drawpixel(cx+y,cy+x, color);
      //lcdg_drawpixel(cx-y,cy+x, color);
      //lcdg_drawpixel(cx+y,cy-x, color);
      //lcdg_drawpixel(cx-y,cy-x, color);

        GRF_drwline(cx-x,cy-y,cx+x,cy-y,color);
        GRF_drwline(cx-x,cy+y,cx+x,cy+y,color);

        GRF_drwline(cx-y,cy-x,cx+y,cy-x,color);
        GRF_drwline(cx-y,cy+x,cx+y,cy+x,color);
   }
}


/*****************************************************************************/
/* Zeichnet einen Kreis um die angebene Position                             */
/*****************************************************************************/

void lcdg_filledcircle(unsigned char xCenter, unsigned char yCenter, 
                 unsigned char radius, unsigned char color)
{
   unsigned int x= 0;
   unsigned int y= radius;
   signed int p= (5- radius*4)/4;

   circlelines(xCenter, yCenter, x, y, color);
   while (x<y) {
      x++;
      if (p<0) {
	 p += 2 * x + 1;
      } else {
	 y--;
	 p += 2 * (x-y)+1;
      }
      circlelines(xCenter, yCenter, x, y, color);
   }
}


/*****************************************************************************/
/*  Linie von (x1, y1) nach (x2, y2) zeichnen.                               */
/*  Erwartet das  x1 < x2 und die Steigung kleiner 1.                        */
/*****************************************************************************/
void GRF_drwline(int Ax, int Ay, int Bx,
               int By, unsigned char Color)
{

	 int dX;	
	 int dY;

	int Xincr, Yincr;

    dX = abs(Bx-Ax);
    dY = abs(By-Ay);

	if (Ax > Bx) { Xincr=-1; } else { Xincr=1; }
	if (Ay > By) { Yincr=-1; } else { Yincr=1; }

	if (dX >= dY)	
	{
		int dPr 	= dY<<1;         
		int dPru 	= dPr - (dX<<1); 
		int P 		= dPr - dX;  

		for (; dX>=0; dX--)          
		{
			lcdg_drawpixel(Ax, Ay, Color); 
			if (P > 0)             
			{
				Ax+=Xincr;
				Ay+=Yincr;
				P+=dPru;  
			}
			else              
			{
				Ax+=Xincr;
				P+=dPr;   
			}
		}
	}
	else            
	{
		int dPr 	= dX<<1;     
		int dPru 	= dPr - (dY<<1); 
		int P 		= dPr - dY; 

		for (; dY>=0; dY--)         
		{
			lcdg_drawpixel(Ax, Ay, Color);
			if (P > 0)            
			{
				Ax+=Xincr;    
				Ay+=Yincr;    
				P+=dPru;      
			}
			else                  
			{
				Ay+=Yincr;    
				P+=dPr;       
			}
		}
	}
}



/*************************************************************************/
/* Zeichnet eine Kiste                                                   */
/*************************************************************************/

void lcdg_box(int x1, int y1, int x2, int y2, int color )
{
     GRF_drwline(x1,y1,x2,y1,color);
     GRF_drwline(x1,y2,x2,y2,color);
     GRF_drwline(x1,y1,x1,y2,color);
     GRF_drwline(x2,y1,x2,y2,color);
}


/*************************************************************************/
/* Zeichnet eine gefuellte Kiste                                         */
/*************************************************************************/

void lcdg_fillbox(int x1, int y1, int x2, int y2, int color )
{ int i;
 for(i=x1;i<=x2;i++) {GRF_drwline(i,y1,i,y2,color);};
}


/*****************************************************************************/
/* Setzt den Charaktercursor an eine bestimmte Pixelposition                 */
/* Dabei ist 0,0 die linke obere Ecke			   		                     */
/*****************************************************************************/
void lcdg_gotoxy(int x, int y)
{ 
   lcdg_xpos = 8 * x;
   lcdg_ypos = 8 * y + 8;
}


void lcdg_gotoxypixel(int x, int y)
{
   lcdg_xpos = x;
   lcdg_ypos = y;
}

/*****************************************************************************/
/* Liefert maximale Zeichenanzahl in X-Richtung                              */
/*****************************************************************************/
int lcdg_maxx(void)
{
  return(MAXLCDG_X / 8);   
}


/*****************************************************************************/
/* Liefert maximale Zeichenanzahl in Y-Richtung                              */
/*****************************************************************************/
int lcdg_maxy(void)
{
  return(MAXLCDG_Y / 8);   
}


/*****************************************************************************/
/* Setzt den Cursor ein Zeichen weiter. Dabei wird am Zeilenende automatisch */
/* ein Zeilenumbruch durchgefuehrt                                           */
/*****************************************************************************/
void lcdg_incpos(void)
{
 
   lcdg_xpos+=8;
   if (lcdg_xpos>MAXLCDG_X) {
      lcdg_xpos=0;
      lcdg_ypos+=8;
   }
   if (lcdg_ypos>MAXLCDG_Y) lcdg_ypos=0;
   
}

/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/
//AUS der firmen api
//grafik funktions


void lcdg_line(int Ax, int Ay, int Bx,
               int By, unsigned char Color)
{

	 int dX;	
	 int dY;

	int Xincr, Yincr;

    dX = abs(Bx-Ax);
    dY = abs(By-Ay);

	if (Ax > Bx) { Xincr=-1; } else { Xincr=1; }
	if (Ay > By) { Yincr=-1; } else { Yincr=1; }

	if (dX >= dY)	
	{
		int dPr 	= dY<<1;         
		int dPru 	= dPr - (dX<<1); 
		int P 		= dPr - dX;  

		for (; dX>=0; dX--)          
		{
			lcdg_drawpixel(Ax, Ay, Color); 
			if (P > 0)             
			{
				Ax+=Xincr;
				Ay+=Yincr;
				P+=dPru;  
			}
			else              
			{
				Ax+=Xincr;
				P+=dPr;   
			}
		}
	}
	else            
	{
		int dPr 	= dX<<1;     
		int dPru 	= dPr - (dY<<1); 
		int P 		= dPr - dY; 

		for (; dY>=0; dY--)         
		{
			lcdg_drawpixel(Ax, Ay, Color);
			if (P > 0)            
			{
				Ax+=Xincr;    
				Ay+=Yincr;    
				P+=dPru;      
			}
			else                  
			{
				Ay+=Yincr;    
				P+=dPr;       
			}
		}
	}
}

void rasterCircle(int x0, int y0, int radius,int col)
 {
   int f = 1 - radius;
   int ddF_x = 0;
   int ddF_y = -2 * radius;
   int x = 0;
   int y = radius;
 
   setPixel(x0, y0 + radius,col);
   setPixel(x0, y0 - radius,col);
   setPixel(x0 + radius, y0,col);
   setPixel(x0 - radius, y0,col);
 
   while(x < y) 
   {
     if(f >= 0) 
     {
       y--;
       ddF_y += 2;
       f += ddF_y;
     }
     x++;
     ddF_x += 2;
     f += ddF_x + 1;
 
     setPixel(x0 + x, y0 + y,col);
     setPixel(x0 - x, y0 + y,col);
     setPixel(x0 + x, y0 - y,col);
     setPixel(x0 - x, y0 - y,col);
     setPixel(x0 + y, y0 + x,col);
     setPixel(x0 - y, y0 + x,col);
     setPixel(x0 + y, y0 - x,col);
     setPixel(x0 - y, y0 - x,col);
   }
 }

//aus t6963c.c

/**
	@brief	Draws a circle 
			In Anlehnung an Bresenham (http://groups.google.de/group/maus.mathe/browse_thread/thread/8a44a51d3f43c23d/ oder 
			http://groups.google.de/group/maus.lang.tpascal/browse_thread/thread/38f9e6d81de037f4/) wird nur 1/4 Kreis berechnet und
			die anderen 3/4 gespiegelt => schnell, da ohne floats
	@param 	x, y: center
			radius
			Set show1 to 1 to draw pixel, set to 0 to hide pixel.
	@return	none
*/
void glcd_circle(int x, int y, int radius, unsigned char show)
{
  int xc = 0;
  int yc ;
  int p ;
  yc=radius;
  p = 3 - (radius<<1);
  while (xc <= yc)  
  {
    setPixel(x + xc, y + yc, show);
    setPixel(x + xc, y - yc, show);
    setPixel(x - xc, y + yc, show);
    setPixel(x - xc, y - yc, show);
    setPixel(x + yc, y + xc, show);
    setPixel(x + yc, y - xc, show);
    setPixel(x - yc, y + xc, show);
    setPixel(x - yc, y - xc, show);
    if (p < 0)
      p += (xc++ << 2) + 6;
    else
      p += ((xc++ - yc--)<<2) + 10;
  }
}

 
void glcd_circle_half(int x, int y, int radius, unsigned char show)
{
  int xc = 0;
  int yc ;
  int p ;
  yc=radius;
  p = 3 - (radius<<1);
  while (xc <= yc)  
  {
//    glcd_pixel(x + xc, y + yc, show);
    setPixel(x + xc, y - yc, show);
//    glcd_pixel(x - xc, y + yc, show);
    setPixel(x - xc, y - yc, show);
//    glcd_pixel(x + yc, y + xc, show);
    setPixel(x + yc, y - xc, show);
//    glcd_pixel(x - yc, y + xc, show);
    setPixel(x - yc, y - xc, show);
    if (p < 0)
      p += (xc++ << 2) + 6;
    else
      p += ((xc++ - yc--)<<2) + 10;
  }
}
//hierzu  musste math.h mit eingebunden werden
/**
	@brief	Draws a segment of a circle 
			
	@param 	x, y: center
			radius
			Startwinkel, Endwinkel. 0=unten, 90 = rechts
			Set show1 to 1 to draw pixel, set to 0 to hide pixel.
	@return	none
*/
void glcd_circle_segment(int x, int y, int radius, int winkel_start, int winkel_end, unsigned char show)
{
	int	x_kreis, y_kreis;
	float winkel;
	#define DEGREE 2*3.14159265/360	
	
	for (winkel = (float)winkel_start; winkel <= winkel_end; winkel += .9)
	{
		x_kreis = (int) (sin (winkel * DEGREE) * radius);
		y_kreis = (int) (cos (winkel * DEGREE) * radius);
		setPixel(x + x_kreis, y + y_kreis, show);
	}
}

//modifiziert 092

//in t6963c.c ist eine weitere fon routine
//ape hat was zum ellipsen zeichnen in glcd_v11_C.zip glcd.c
//aus glcd6.c drumpad/ellipsen



//modifiziert void rasterCircle(int x0, int y0, int radius,int col)
//linien eingefgt um gefllten kreis zu zeichnen
void drawFilledCircle(int x0, int y0, int radius,int col)
 {
    static int lasty=0;
   int f = 1 - radius;
   int ddF_x = 0;
   int ddF_y = -2 * radius;
   int x = 0;
   int y = radius;
 
   //setPixel(x0, y0 + radius,col);//unten
   //setPixel(x0, y0 - radius,col);//oben
   //setPixel(x0 + radius, y0,col);//rechts
   //setPixel(x0 - radius, y0,col);//links
    lcdg_line(x0 - radius,y0,x0 + radius,y0,col); 
   while(x < y) 
   {

     if(f >= 0) 
     {
        lcdg_line(x0 - x,y0 + y,x0 + x,y0 + y,col);
        lcdg_line(x0 - x,y0 - y,x0 + x,y0 - y,col);
        y--;
        ddF_y += 2;
        f += ddF_y;
     }
     x++;
     lcdg_line(x0 - y,y0 + x,x0 + y,y0 + x,col);
     lcdg_line(x0 - y,y0 - x,x0 + y,y0 - x,col);
     ddF_x += 2;
     f += ddF_x + 1;

/* 
     setPixel(x0 + x, y0 + y,col);//unten rechts / unten
     setPixel(x0 - x, y0 + y,col);//untenn links / unten
     setPixel(x0 + x, y0 - y,col);//oben rechts / oben
     setPixel(x0 - x, y0 - y,col);//oben links / oben
     setPixel(x0 + y, y0 + x,col);//unten rechts / rechts
     setPixel(x0 - y, y0 + x,col);//unten links / links
     setPixel(x0 + y, y0 - x,col);//oben rechts / rechts 
     setPixel(x0 - y, y0 - x,col);//oben links / links
*/
     //Sleep(50);
     //SLM1606M_update(hDC);
   }
 }









