

//*****************************
//********* Includes **********
//*****************************

#ifndef SOFTTIMER_H
#define SOFTTIMER_H

#include <inttypes.h>
#ifdef AVR
#include "slm1606m.h"
#endif

//*****************************
//********* Constants *********
//*****************************



#define SoftTimer_kTimerTickInMicroSecs  1000

typedef enum tag_Softtimer_ETimer
{
    Softtimer_kTimer0 = 0,
    Softtimer_kTimer1,
    Softtimer_kTimer2,
    Softtimer_kTimer3,
    Softtimer_kTimer4,
    Softtimer_kTimer5,
    Softtimer_kTimer6,
    Softtimer_kTimer7,
    Softtimer_kTimer8,
    Softtimer_kTimer9,
    Softtimer_kTimer10,
    Softtimer_kTimer11,
    Softtimer_kTimer12,
    Softtimer_kTimer13,
    Softtimer_kTimer14,
    Softtimer_kTimer15,
    Softtimer_kMaxNumberOfTimers
}Softtimer_ETimer;



//***************************************************************************
//*
//* FUNCTION
//* Softtimer__Init - Initialisierung der Softwaretimer
//*
//***************************************************************************
void Softtimer__Init (void);



//***************************************************************************
//*
//* FUNCTION
//* SWTimer - bearbeitet die SoftwareTimer
//*
//***************************************************************************

//Das Programm   T I M E R   verwaltet bis zu 8 Softwaretimer.
//Zeitbasis fuer die Softwaretimer ist Timer0 oder Timer1 des 8051.
//Er muss in Modus 2 (Reload) mit einem Reload-Wert von -250 arbeiten und
//einen Timer-Int. ausloesen (alle 250 us bei 12 MHz, bei anderem Quarz Reload-
//Wert korr.). Innerhalb der Int.-Routine muss das DATAByte TIMERX inc. werden.
//Hat TIMERX den Wert 4 erreicht (1 ms verstrichen), so werden alle aktiven
//Softwaretimer dec..
//Jeder Softwaretimer hat eine Groesse von 16 Bit und kann somit bis zu
//65,535 s zaehlen. Gestartet wird der Timer durch Setzen seines Bits in
//TIMEFG (Bit 0 fuer TIMER0, Bit 1 fuer TIMER1 usw.). Ist der Timer fertig,
//so loescht er sein Bit wieder.


void Softtimer__Handler (void);


void Softtimer__Load ( Softtimer_ETimer timer, uint16_t milliSecs );


uint8_t Softtimer__Expired ( Softtimer_ETimer timer );

#endif
